<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<%@ page import="org.wso2.carbon.registry.ui.info.clients.InfoServiceClient" %>
<%@ page import="org.wso2.carbon.registry.ui.info.beans.xsd.EventTypeBean" %>
<%@ page import="org.wso2.carbon.registry.ui.info.beans.xsd.SubscriptionBean" %>
<%@ page import="org.wso2.carbon.registry.ui.info.services.utils.xsd.EventType" %>
<%@ page import="org.wso2.carbon.registry.ui.info.services.utils.xsd.SubscriptionInstance" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<script type="text/javascript" src="../info/js/info.js"></script>
<script type="text/javascript" src="../ajax/js/prototype.js"></script>

<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    String[] events = null;
    String[] resourceEventNames = null;
    String[] collectionEventNames = null;
    SubscriptionInstance[] subscriptions = null;
    boolean isResource = true;
    boolean canUnsubscribe = false;
    boolean canSubscribeOthers = false;
    boolean canAdd = true;
    String username = null;
    boolean displayPlainError = true;
    String url = null;
    try{
        InfoServiceClient client = null;
        if (request.getParameter("endpoint") != null && request.getParameter("eventName") != null) {
            client = new InfoServiceClient(cookie, config, session);
            if (request.getParameter("doRest") == null) {
                client.subscribe(request);
            } else {
                client.subscribeREST(request);
            }
        } else if (request.getParameter("id") != null) {
            client = new InfoServiceClient(cookie, config, session);
            client.unsubscribe(request);
        } else {
            displayPlainError = false;
            client = new InfoServiceClient(cookie, config, session);
        }
        if (request.getParameter("path") != null) {
             url = client.getRemoteURL(request.getParameter("path"));
        }
        if (url == null) {
            SubscriptionBean subscriptionBean = client.getSubscriptions(request);
            // FIXME: fix issue related to subscriptionBean.getLoggedIn() on WAS, and uncomment the
            // line below.
            //if (!subscriptionBean.getLoggedIn() || subscriptionBean.getVersionView()) {
            if (subscriptionBean.getVersionView()) {
                canAdd = false;
            }
            subscriptions = subscriptionBean.getSubscriptionInstances();
            EventTypeBean eventTypeBean = client.getEventTypes(request);
            EventType[] eventTypes = eventTypeBean.getEventTypes();
            events = new String[eventTypes.length];
            resourceEventNames = new String[eventTypes.length];
            collectionEventNames = new String[eventTypes.length];
            for (int i = 0; i < eventTypes.length; i++) {
                if (eventTypes[i] != null) {
                    events[i] = eventTypes[i].getId();
                    resourceEventNames[i] = eventTypes[i].getResourceEvent();
                    collectionEventNames[i] = eventTypes[i].getCollectionEvent();
                }
            }
            isResource = client.isResource(request);
            canUnsubscribe = (subscriptionBean.getUserAccessLevel() > 0);
            canSubscribeOthers = (subscriptionBean.getUserAccessLevel() > 2);
            username = subscriptionBean.getUserName();
        }
    } catch (Exception e){
        response.setStatus(500);
        if (displayPlainError) {
            %><%=e.getMessage()%><%
            return;
        }
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
        <jsp:include page="../admin/error.jsp?<%=e.getMessage()%>"/>
<%
        return;
    }
    if (url != null) {
        if (canAdd) {
%>
<fmt:bundle basename="org.wso2.carbon.registry.ui.info.i18n.Resources">
<div class="icon-link-ouside">
    <a class="icon-link" target="_blank" style="background-image:url(../admin/images/add.gif);" href="<%=url%>">
        <fmt:message key="add.remote.subscription"/></a>
</div>
<div id="subscriptionsSummary" class="summeryStyle"><fmt:message key="click.to.add.subscription.to.remote.resource"/></div>
</fmt:bundle>
<%
        }
    } else {
%>
<fmt:bundle basename="org.wso2.carbon.registry.ui.info.i18n.Resources">
<%
    if (canAdd) {
%>
<div class="icon-link-ouside">
    <a class="icon-link" style="background-image:url(../admin/images/add.gif);" href="javascript:void(0)"
       onclick="javascript:showHideCommon('add-subscription-div');if($('add-subscription-div').style.display!='none')$('eventList').focus();">
        <fmt:message key="add.subscription"/></a>
</div>
<%
    }
%>
<div id="add-subscription-div" style="display:none;padding-bottom:10px;">
    <table cellpadding="0" cellspacing=10 border="0" width="100%">
        <tr>
            <td valign="middle" style="width:30px;text-align:left"><fmt:message key="event"/>&nbsp;<span class="required">*</span></td>
            <td valign="top" style="width:70px;text-align:left;">
                <select id="eventList" onchange="changeVisibility()">
                    <option value="0"><fmt:message key="select"/></option>
<%
    for (int i = 0; i < events.length; i++) {
        if (isResource) {
            if (resourceEventNames[i] != null) {
%>
                    <option value="<%=resourceEventNames[i]%>"><fmt:message key="<%=events[i]%>"/></option>
<%
            }
        } else if (collectionEventNames[i] != null) {
%>
                    <option value="<%=collectionEventNames[i]%>"><fmt:message key="<%=events[i]%>"/></option>
<%
        }        
    }
%>
                </select>
            </td>
        </tr>
        <tr>
            <td valign="middle" style="width:30px;text-align:left"><fmt:message key="notification.method"/>&nbsp;<span class="required">*</span></td>
            <td valign="top" style="width:70px;text-align:left;">
                <select id="notificationMethodList" disabled="disabled" onchange="changeVisibility()">
                    <option value="0"><fmt:message key="select"/></option>
                    <option value="1"><fmt:message key="email"/></option>
                    <option value="2"><fmt:message key="html.plain.text"/></option>
                    <option value="3"><fmt:message key="soap"/></option>
                    <option value="4"><fmt:message key="username"/></option>
                </select>
            </td>
        </tr>
        <tr id="subscriptionDataInputRecord" style="display:none">
            <td colspan="2">
                <div id="subscriptionDataEmail" style="display:none">
                    <p style="padding:0 0 5px 0"><fmt:message key="enter.email"/></p>
                    <p>
                        <fmt:message key="enter.email.prompt"/>&nbsp;<span class="required">*</span>&nbsp;&nbsp;<input type="text" id="subscriptionEmail" />
                    </p>
                </div>
                <div id="subscriptionDataHTMLSOAP" style="display:none">
                    <p style="padding:0 0 5px 0"><fmt:message key="enter.url"/></p>
                    <p>
                        <fmt:message key="enter.url.prompt"/>&nbsp;<span class="required">*</span>&nbsp;&nbsp;<input type="text" id="subscriptionURL" />
                    </p>
                </div>
                <div id="subscriptionDataUserProfile" style="display:none">
<%
    if (canSubscribeOthers) {
%>
                    <p style="padding:0 0 5px 0"><fmt:message key="enter.username"/></p>
                    <p>
                        <fmt:message key="enter.username.prompt"/>&nbsp;<span class="required">*</span>&nbsp;&nbsp;<input type="text" id="subscriptionUserProfile" />
                    </p>
<%
    } else {
%>
                    <p style="padding:0 0 5px 0"><fmt:message key="enter.username.me"/></p>
                    <p>
                        <fmt:message key="enter.username.prompt"/>:&nbsp;&nbsp;<%=username%>
                        <input type="hidden" id="subscriptionUserProfile" value="<%=username%>" /> 
                    </p>
<%
    }
%>
                </div>
            </td>
        </tr>
        <tr>
            <td colspan="2" class="buttonRow">
                <input type="button" id="subscribeButton" class="button" value="<fmt:message key="subscribe"/>"
                        onclick="subscribe('<%=request.getParameter("path")%>');" disabled="disabled"/>&nbsp;
                <input type="button"
                        class="button"
                        value="<fmt:message key="cancel"/>"
                        onclick="showHideCommon('add-subscription-div');"/>
            </td>
        </tr>
    </table>
    <div style="font-style:italic;margin-top:5px;">
        <img src="../info/images/help-small.jpg" style="margin-right:5px;"/>
            <fmt:message key="select.event.type.and.notification.method"/>
    </div>
</div>

<%
    if (subscriptions.length == 0 || subscriptions[0] == null) {
%>
<div id="subscriptionsSummary" class="summeryStyle"><fmt:message key="no.subscriptions"/></div>
<%
    } else {
        if (subscriptions.length == 1) {
%>
<div id="subscriptionsSummary" class="summeryStyle"><fmt:message key="one.subscription"/></div>
<%
        } else {
%>
<div id="subscriptionsSummary" class="summeryStyle"><fmt:message key="no.of.subscriptions"><fmt:param><%=subscriptions.length%></fmt:param></fmt:message></div>
<%
        }
%>
    <table cellpadding="0" cellspacing=8 border="0" width="100%" class="styledLeft" id="subscriptionsTable">
        <tr>
            <td valign="top" style="text-align:left;width:65%;"><fmt:message key="subscriptions"/></td>
            <td valign="top" style="text-align:left;width:35%;"><fmt:message key="actions"/></td>
        </tr>
<%
        for (SubscriptionInstance subscription : subscriptions) {
            if (subscription == null) {
                continue;
            }
            String address = null;
            String notificationMethod = subscription.getNotificationMethod();
            if (notificationMethod.equals("email")) {
                address = subscription.getAddress().substring(7);
            } else if (notificationMethod.equals("username")) {
                address = subscription.getAddress().substring(7);
            } else {
                address = subscription.getAddress();
                notificationMethod = "url";
            }
            String notificationMethodPrompt = "enter." + notificationMethod + ".prompt";
            String eventName = subscription.getEventName();
            String eventId = null;
            for (int i = 0; i < events.length; i++) {
                if (eventName.equals(resourceEventNames[i]) || eventName.equals(collectionEventNames[i])) {
                    eventId = events[i];
                    break;
                }
            }
            if (eventId != null) {
%>
        <tr>
            <td valign="top" style="text-align:left;width:65%;padding:0 8px 0 2px;">
                <fmt:message key="subscription">
                    <fmt:param><fmt:message key="<%=eventId%>"/></fmt:param>
                    <fmt:param><abbr title='<fmt:message key="<%=notificationMethodPrompt%>"/>: <%=address%>'><fmt:message key="<%=notificationMethod%>"/></abbr></fmt:param>
                </fmt:message>
            </td>
<%
                if (canUnsubscribe) {
%>
            <td valign="top" style="text-align:center;width:35%">
                <a href="javascript:void(0)" onclick="unsubscribe('<%=request.getParameter("path")%>','<%=subscription.getId()%>');"><img src="../admin/images/delete.gif" /></a>&nbsp;
                <a href="javascript:void(0)" onclick="unsubscribe('<%=request.getParameter("path")%>','<%=subscription.getId()%>');"><fmt:message key="delete"/></a>
            </td>
<%
                } else {
%>
            <td valign="top" style="text-align:right;width:35%"></td>
<%
                }
%>
        </tr>
<%
            }
        }
%>
    </table>
    <script type="text/javascript">
        alternateTableRows('subscriptionsTable', 'tableEvenRow', 'tableOddRow');
    </script>
<%
    }
%>
    </fmt:bundle>
<%
    }
%>
